package com.ruoyi.gysl.controller;


import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.gysl.entity.Fmqd;
import com.ruoyi.gysl.service.FmqdService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

import java.util.List;

/**
 * 负面清单管理(FmqdController)表控制层
 *
 */
@Api(tags ="负面清单管理" )
@RestController
@RequestMapping("/gysl/Fmqd")
public class FmqdController extends BaseController {

    @Resource
    private FmqdService fmqdService;

    /**
     * 分页查询负面清单数据
     *
     * @param fmqd 查询条件实体
     * @return 分页数据
     */
    @GetMapping("/list")
    @ApiOperation("分页查询负面清单数据")
    public TableDataInfo list(Fmqd fmqd) {
        startPage(); // 开启分页
        List<Fmqd> list = fmqdService.selectFmqdList(fmqd);
        return getDataTable(list);
        // 封装分页结果
    }
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    @ApiOperation("通过主键查询负面清单数据")
    public AjaxResult select(@PathVariable Integer id){
        return success(fmqdService.selectFmqdId(id));
    }
    /**
     * 新增数据
     *@param fmqd 实体对象
     * @return 新增结果
     */
    @PostMapping("/add")
    @ApiOperation("新增数据")
    public AjaxResult add(@RequestBody Fmqd fmqd) {
        return success(fmqdService.save(fmqd));
    }

    /**
     * 修改数据
     *
     * @param fmqd 实体对象
     * @return 修改结果
     */
    @PostMapping("/edit")
    @ApiOperation("修改数据")
    public AjaxResult update(@RequestBody Fmqd fmqd) {
        return success(fmqdService.updateById(fmqd));
    }
    /**
     * 删除数据
     *
     * @param id 实体对象
     * @return 删除结果
     */
    @DeleteMapping("/delete/{id}")
    @ApiOperation("删除数据")
    public AjaxResult delete(@PathVariable Integer id) {
        return success(fmqdService.deleteMapping(id));
    }

}
