package com.ruoyi.gysl.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.gysl.entity.MonthInformation;
import com.ruoyi.gysl.service.MonthInformationService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;


@Api(tags = "月度进展信息")
@RestController
@RequestMapping("gysl/MonthInformation")
public class MonthInformationController extends BaseController {
    /**
     * 服务对象
     */
    @Resource
    private MonthInformationService monthInformationService;
    /**
     * 分页查询月度进展信息
     *
     * @param monthInformation 查询实体
     * @return 所有数据
     */
    @GetMapping("/list")
    @ApiOperation("分页查询月度进展信息")
    public TableDataInfo list(MonthInformation monthInformation){
        startPage();
        List<MonthInformation> list = monthInformationService.selectMonthInformation(monthInformation);
        return getDataTable(list);
    }
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    @ApiOperation("通过主键查询月度进展信息")
    public AjaxResult select(@PathVariable Integer id){
        return success(monthInformationService.selectMonthInformationId(id));
    }
    /**
     * 新增数据
     *
     * @param monthInformation 查询条件实体
     * @return 新增结果
     */
    @PostMapping("/add")
    @ApiOperation("新增数据")
    public AjaxResult add(@RequestBody MonthInformation monthInformation){
        return success(monthInformationService.saveMonthInformation(monthInformation));
    }
    /**
     * 修改数据
     *
     * @param monthInformation 实体对象
     * @return 修改结果
     */
    @PostMapping("edit")
    @ApiOperation("修改")
    public AjaxResult edit(@RequestBody MonthInformation monthInformation){
        return success(monthInformationService.updateById(monthInformation));
    }
    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除结果
     */
    @DeleteMapping("/delete/{id}")
    @ApiOperation("删除数据")
    public AjaxResult delete(@PathVariable Integer id){
        return success(monthInformationService.deleteMonthInformation(id));
    }
}
