package com.ruoyi.gysl.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 月度进展信息(MonthInformation)实体类
 *
 */
@Data
@ApiModel(value = "MonthInformation", description = "月度进展信息")
public class MonthInformation {

    //主键id
    @ApiModelProperty("主键id")
    private Integer id;

    //项目id
    @ApiModelProperty("项目id")
    private Integer xmId;

    //进度月份
    @ApiModelProperty("进度月份")
    private String month;

    //状态
    @ApiModelProperty("状态")
    private Integer status;

    //当月完成投资
    @ApiModelProperty("当月完成投资")
    private BigDecimal dywctz;

    //累计完成投资
    @ApiModelProperty("累计完成投资")
    private BigDecimal ljwctz;

    //截至目前累计建成面积
    @ApiModelProperty("截至目前累计建成面积")
    private BigDecimal jzmqljjcmj;

    //贷款额度
    @ApiModelProperty("贷款额度")
    private BigDecimal dked;

    //从选区创建新的临时文件
    @ApiModelProperty("项目进展详情")
    private BigDecimal xmjzqk;

    //创建者id
    @ApiModelProperty("创建者id")
    private Integer createId;

    //创建时间
    @ApiModelProperty("创建时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime createTime;

    //创建者
    @ApiModelProperty("创建者")
    private String createBy;

    //更新者id
    @ApiModelProperty("更新者id")
    private Long updateId;

    //更新者
    @ApiModelProperty("更新者")
    private String updateBy;

    //更新时间
    @ApiModelProperty("更新时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateTime;
}




