package com.ruoyi.gysl.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.gysl.entity.baseModel.BaseModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.time.LocalDate;

/**
 * 项目巡礼(Xmxl)表实体类
 *
 * @author makejava
 * @since 2025-03-21 14:15:38
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("gysl_xmxl")
public class Xmxl extends BaseModel implements Serializable {

    @TableId(type = IdType.AUTO)
    private Long id;

    @ApiModelProperty("项目id")
    private Long xmId;

    @ApiModelProperty("项目名称")
    private String xmmc;

    @ApiModelProperty("年度")
    private String year;

    @ApiModelProperty("网页地址")
    private String webUrl;

    @ApiModelProperty("时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate sj;

    @ApiModelProperty("图片上传")
    private String img;
    
    @ApiModelProperty("说明")
    private String content;

    @ApiModelProperty("大事记")
    private String bigEvent;

    @ApiModelProperty("新闻事件")
    private String newsEvent;

    @ApiModelProperty("附件上传")
    private String fj;

}

