package com.ruoyi.gysl.entity.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 目录分页查询参数
 * @author du
 * @since 2025/3/22 9:50
 */
@Data
public class MlPageReq {

    @ApiModelProperty("上楼目录类别")
    private Integer slmllb;

    @ApiModelProperty("工业大类")
    private String gydl;

    @ApiModelProperty("产业")
    private String cy;

    @ApiModelProperty(value = "更新开始时间 yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate startTime;

    @ApiModelProperty(value = "更新结束时间 yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate endTime;
}
