package com.ruoyi.gysl.entity.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

@Data

public class MmmRequest {
    // 主键id 自增
    @ApiModelProperty("id")
    private Integer id;

    @ApiModelProperty("文件标题")
    private String documentTitle;

    @ApiModelProperty("发布单位")
    private String publishUnit;

    @ApiModelProperty("发布人")
    private String publisher;

    @ApiModelProperty("发布时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime publishTime;

    @ApiModelProperty("发布内容")
    private String publishingContent;

    @ApiModelProperty("创建者id")
    private Integer createId;

    @ApiModelProperty("发布开始时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime publishStarTime;

    @ApiModelProperty("发布结束时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime publishEndTime;

    @ApiModelProperty("页码")
    private Long current=1L;

    @ApiModelProperty("页数")
    private Long size=10L;

}

