package com.ruoyi.gysl.entity.response;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * 项目导出信息
 * @author du
 * @since 2025/3/14 14:01
 */
@Data
public class ProjectExcelInfo {
    @Excel(name = "项目法人单位",height=30)
    @ApiModelProperty("项目法人单位")
    private String xmfrdwxz;



    @Excel(name = "项目法人单位性质",dictType = "xmfrdwxz",width = 20)
    @ApiModelProperty("项目法人单位性质")
    private Integer nature;

    @Excel(name = "项目名称")
    @ApiModelProperty("项目名称")
    private String name;

    @Excel(name = "现状分类（已建/在建/拟建）",dictType = "xzfl", comboReadDict = true,width = 24)
    @ApiModelProperty("现状分类")
    private Integer xzfl;

    @ApiModelProperty("项目建设开始时间 yyyy-MM")
    @Excel(name = "项目建设开始时间")
    private String begainTime;

    @ApiModelProperty("项目建设结束时间 yyyy-MM")
    @Excel(name = "项目建设结束时间")
    private String endTime;

    @ApiModelProperty("计划投资额")
    @Excel(name = "计划投资额（亿元）",width = 20)
    private BigDecimal jhtze;

    //--规划信息
    @Excel(name = "总用地面积（平方米）",width = 20)
    @ApiModelProperty(value = "总用地面积（平方米）")
    private BigDecimal zydmj;

    @Excel(name = "容积率")
    @ApiModelProperty(value = "容积率")
    private BigDecimal rjl;

    @Excel(name = "总建筑面积（平方米）")
    @ApiModelProperty(value = "总建筑面积")
    private BigDecimal zjzmj;

    @Excel(name = "标准层建筑面积（千平方米）",width = 20)
    @ApiModelProperty(value = "标准层建筑面积")
    private String bzcjzmj;


    //---------

    @Excel(name = "重点发展产业（原则上不超过三个）",width = 20)
    @ApiModelProperty("重点发展产业")
    private String prioritize;

    @ApiModelProperty("项目负责人")
    @Excel(name = "项目负责人")
    private String projectLeader;

    @NotBlank
    @ApiModelProperty("联系方式")
    @Excel(name = "联系方式",type = Excel.Type.EXPORT)
    private String phone;

    @ApiModelProperty("建设进度")
    @Excel(name = "建设进度（或运营情况）")
    private String jsjd;

    @Excel(name = "建设模式（新供地实施/利用存量用地改扩建）",width = 22,dictType = "jsms",comboReadDict = true)
    @ApiModelProperty("建设模式")
    private Integer jsms;


    //=====已有项目导入需要的字段
    @ApiModelProperty("项目建设起止时间")
    @Excel(name = "项目建设起止时间")
    private String a1;

}
