package com.ruoyi.gysl.mapper;

import com.ruoyi.gysl.entity.Fmqd;
import io.lettuce.core.dynamic.annotation.Param;
import org.mapstruct.Mapper;

import java.util.List;
/**
 * 负面清单管理(Fmqd)表数据库访问层
 */
@Mapper
public interface FmqdServiceMapper {
    /**
     * 分页查询负面清单数据
     *
     * @param fmqd 查询条件实体
     * @return 分页数据
     */
    List<Fmqd> selectFmqdList(Fmqd fmqd);
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    Fmqd selectFmqdById(Integer id);
    /**
     * 新增数据
     *@param fmqd 实体对象
     * @return 新增结果
     */
    int saveFmqd(Fmqd fmqd);
    /**
     * 修改数据
     *
     * @param fmqd 实体对象
     * @return 修改结果
     */
    int updateFmqd(Fmqd fmqd);
    /**
     * 删除数据
     *
     * @param id 实体对象
     * @return 删除结果
     */
    int deleteFmqd(Integer id);
}