package com.ruoyi.gysl.mapper;

import com.ruoyi.gysl.entity.MonthInformation;
import org.mapstruct.Mapper;

import java.util.List;

/**
 * 月度进展信息(MonthInformtion)表数据库访问层
 */
@Mapper
public interface MonthInformationMapper {
    /**
     * 查询分页信息
     *
     * @param monthInformation 查询条件实体
     * @return 目录数据列表
     */
    List<MonthInformation> selectMonthInformationList(MonthInformation monthInformation);
    /**
     * 查询月度进展信息单条信息
     *
     * @param id 查询条件
     * @return 月度进展信息单条数据
     */
    MonthInformation selectMonthInformationId(Integer id);
    /**
     * 增加数据
     *
     * @param monthInformation 数据
     * @return 新增结果
     */
    int save(MonthInformation monthInformation);
    /**
     * 修改数据
     *
     * @param monthInformation 数据
     * @return 修改结果
     */
    int updateMonthInformation(MonthInformation monthInformation);
    /**
     * 删除数据
     * @param id 数据
     * @return 删除结果
     */
    int deletemonthInformation(Integer id);
}
