package com.ruoyi.gysl.service.impl;

import cn.hutool.core.io.resource.ClassPathResource;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.docking.entity.SmartDeclaration;
import com.ruoyi.docking.service.SmartDeclarationService;
import com.ruoyi.docking.service.UserService;
import com.ruoyi.gysl.entity.*;
import com.ruoyi.gysl.entity.request.AuditRequest;
import com.ruoyi.gysl.entity.request.BasicInformationPageReq;
import com.ruoyi.gysl.entity.request.RemarkPageReq;
import com.ruoyi.gysl.entity.request.ZwIdPageReq;
import com.ruoyi.gysl.entity.response.BasicInformationResponse;
import com.ruoyi.gysl.entity.response.ProjectExcelInfo;
import com.ruoyi.gysl.mapper.BasicInformationMapper;
import com.ruoyi.gysl.service.*;
import org.apache.poi.xwpf.usermodel.XWPFDocument;
import org.apache.poi.xwpf.usermodel.XWPFParagraph;
import org.apache.poi.xwpf.usermodel.XWPFRun;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.Serializable;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * 基本信息(BasicInformation)表服务实现类
 *
 * @author makejava
 * @since 2025-02-24 09:25:55
 */
@Service("basicInformationService")
public class BasicInformationServiceImpl extends ServiceImpl<BasicInformationMapper, BasicInformation> implements BasicInformationService {


    /**
     * 项目规划信息
     */
    @Resource
    private PlanInformationService planInformationService;


    /**
     * 建筑信息
     */
    @Resource
    private BuildingInformationService buildingInformationService;

    /**
     * 五要素模型信息
     */
    @Resource
    private WysmxInformationService wysmxInformationService;

    /**
     * 企业入驻信息
     */
    @Resource
    private QyrzInformationService qyrzInformationService;

    /**
     * 项目图例信息
     */
    @Resource
    private ProjectLegendService projectLegendService;

    /**
     * 项目备忘录
     */
    @Resource
    private ProjectRemarkService projectRemarkService;

    /**
     * 月度进展信息
     */
//    @Resource
//    private ProjectMonthInfoService projectMonthInfoService;

    @Resource
    private SmartDeclarationService smartDeclarationService;

    @Resource
    private UserService userService;

    /**
     * 项目巡礼
     */
    @Resource
    private XmxlService xmxlService;

    /**
     * 项目备忘录
     */
    @Resource
    private ProjectOtherInfoService otherInfoService;

    /**
     * 入驻的企业
     */
    @Resource
    private EnterpriseService enterpriseService;

    /**
     * 分页查询所有数据
     *
     * @param page 分页对象
     * @param req  查询实体
     * @return 所有数据
     */
    @Override
    public Page<BasicInformation> page(Page<BasicInformation> page, BasicInformationPageReq req) {
        return baseMapper.page(page, req);
    }


    /**
     * 导出项目数据
     */
    @Override
    public List<ProjectExcelInfo> selectList() {
        return baseMapper.selectList();
    }


//    /**
//     * 填充数据
//     */
//    @Override
//    public void approvalMethodfillInData(XSSFSheet sheet, XSSFCellStyle contentStyle, int rowNum, List<ProjectExcelInfo> info, List<String> sc, List<String> ec, int num) {
//        Class<?> classBuilding = ProjectBuildingExcel.class;
//        for (ProjectExcelInfo projectExcelInfo : info) {
//            XSSFRow tempRow = sheet.createRow(rowNum++);
//            tempRow.setHeight((short) 1400);
//            int i1;
//            for (i1 = 0; i1 < sc.size(); i1++) {
//                XSSFCell tempCell = tempRow.createCell(i1);
//                tempCell.setCellStyle(contentStyle);
//                if (!ec.get(i1).endsWith("厂房")) {
//                    if (Objects.equals(sc.get(i1), "")) {
//                        tempCell.setCellValue(projectExcelInfo.getId());
//                    } else {
//                        tempCell.setCellValue(getExcelData(projectExcelInfo, sc.get(i1)));
//                    }
//                }
//            }
////            XSSFCell tempCell = tempRow.createCell(8);
////            tempCell.setCellStyle(contentStyle);
////            tempCell.setCellValue("12312321");
//
//            for (int i2 = 0; i2 < projectExcelInfo.getXmjzxx().size(); i2++) {
//                switch (projectExcelInfo.getXmjzxx().get(i2).getFloor()) {
//                    case 1:
//                        i1 = ec.indexOf("一层厂房");
//                        break;
//                    case 2:
//                        i1 = ec.indexOf("双层厂房");
//                        break;
//                    case 3:
//                        i1 = ec.indexOf("三层厂房");
//                        break;
//                    case 4:
//                        i1 = ec.indexOf("四层厂房");
//                        break;
//                    case 5:
//                        i1 = ec.indexOf("五层厂房");
//                        break;
//                    default:
//                        i1 = ec.indexOf("六层及以上厂房");
//                }
//                for (Field field : classBuilding.getDeclaredFields()) {
//                    XSSFCell tempCell = tempRow.createCell(i1);
//                    tempCell.setCellStyle(contentStyle);
//                    Excel excelColumn = field.getAnnotation(Excel.class);
//                    if (excelColumn != null) {
//                        tempCell.setCellValue(getBuildingData(projectExcelInfo.getXmjzxx().get(i2), sc.get(i1)));
//                        i1++;
//                    }
//                }
//            }
//        }
//    }
//
//    /**
//     * 填充数据-项目基础信息获取
//     */
//    @Override
//    public String getExcelData(ProjectExcelInfo item, String str) {
//        String a = null;
//        switch (str) {
//            case "":
//                a = item.getId() == null ? "-" : item.getId();
//                break;
//            case "项目名称":
//                a = item.getName() == null ? "-" : item.getName();
//                break;
//            case "项目法人单位":
//                a = item.getXmfrdwxz() == null ? "-" : item.getXmfrdwxz();
//                break;
//            case "项目法人单位性质":
//                a = String.valueOf(item.getNature() == null ? "-" : item.getNature());
//                break;
//            case "总用地面积":
//                a = String.valueOf(item.getZydmj() == null ? "-" : item.getZydmj());
//                break;
//            case "容积率":
//                a = String.valueOf(item.getRjl() == null ? "-" : item.getRjl());
//                break;
//            case "总建筑面积":
//                a = String.valueOf(item.getZjzmj() == null ? "-" : item.getZjzmj());
//                break;
//            case "标准层建筑面积":
//                a = String.valueOf(item.getBzcjzmj() == null ? "-" : item.getBzcjzmj());
//                break;
//        }
//        return a;
//    }
//
//    /**
//     * 填充数据-项目建筑信息获取
//     */
//    @Override
//    public String getBuildingData(ProjectBuildingExcel item, String str) {
//        String a = null;
//        switch (str) {
//            case "层数":
//                a = item.getFloor() == null ? "-" : String.valueOf(item.getFloor());
//                break;
//            case "总建筑高度":
//                a = item.getTotalBuildingHeight() == null ? "-" : String.valueOf(item.getTotalBuildingHeight());
//                break;
//            case "首层高度":
//                a = String.valueOf(item.getScgd() == null ? "-" : item.getScgd());
//                break;
//            case "2至4层高":
//                a = String.valueOf(item.getTwoAndFourCg() == null ? "-" : item.getTwoAndFourCg());
//                break;
//            case "4层以上层高":
//                a = String.valueOf(item.getFourYscg() == null ? "-" : item.getFourYscg());
//                break;
//        }
//        return a;
//    }

    /**
     * 有经纬度的项目列表
     */
    @Override
    public Page<BasicInformation> projectList(Page<BasicInformation> page) {
        return baseMapper.projectList(page);
    }

    /**
     * 查看当前用户是否有权限查看或者修改新增
     */
    @Override
    public BasicInformation testXmId(Serializable xmId) {
        BasicInformation byId = getById(xmId);
        // 获取当前登录用户是否是企业端
        try {
            if (SecurityUtils.hasRole("company") && byId != null) {
                if (!Objects.equals(byId.getTyshxydm(), SecurityUtils.getUsername())) {
                    throw new ServiceException("禁止修改!");
                }
            }
        } catch (Exception ignored) {
        }
        return byId;
    }

    /**
     * 企业端和政务端信息修改
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public Long audit(AuditRequest req, int status, int oldStatus) {
        //企业端提交审核直接修改，不需要挂起等待审批
        //修改项目基本信息，和是否是负面清单
        List<WysmxInformation> collect1 = req.getWysmxInformations().stream().filter(x ->
                        "危化品等级".equals(x.getZdname())
                )
                .collect(Collectors.toList());
        List<WysmxInformation> collect2 = req.getWysmxInformations().stream().filter(x ->
                        "生产火灾危险等级".equals(x.getZdname())
                )
                .collect(Collectors.toList());
        List<WysmxInformation> collect3 = req.getWysmxInformations().stream().filter(x ->
                        "环境保护".equals(x.getZdname()))
                .collect(Collectors.toList());
        if (!collect1.isEmpty() && !collect2.isEmpty() && !collect3.isEmpty()) {
            req.getBasicInformation().setIsFmqd(wysmxInformationService.canGoUpstairs(
                    collect1.get(0).getZdinfor(),
                    collect2.get(0).getZdinfor(),
                    collect3.get(0).getZdinfor()) ? 1 : 0);
        }

        //修改项目规划信息
        planInformationService.updateById(req.getPlanInformation());
        //修改企业入驻信息
        qyrzInformationService.updateById(req.getQyrzInformation());
        //修改五要素模型信息
        wysmxInformationService.lambdaUpdate().eq(WysmxInformation::getXmId, req.getBasicInformation().getId()).remove();
        wysmxInformationService.saveBatch(req.getWysmxInformations());
        //修改其他信息
        otherInfoService.lambdaUpdate().eq(ProjectOtherInfo::getXmId, req.getBasicInformation().getId()).remove();
        otherInfoService.saveBatch(req.getProjectOtherInfos());

        if (status == 2) {
            if (oldStatus == 1) {
                userService.getAllZwUser("关于" + req.getBasicInformation().getName() + "项目,待审核的通知", req.getBasicInformation().getId(), null, null);
            }
        }
        if (status == 3) {
            if (oldStatus == 2) {
                SmartDeclaration sd = new SmartDeclaration();
                sd.setTyshxydm((req.getBasicInformation().getTyshxydm()));
                sd.setProjectId(req.getBasicInformation().getId());
                sd.setContent("关于" + req.getBasicInformation().getName() + "项目,审核通过的通知");
                smartDeclarationService.save(sd);
            }
        }
        req.getBasicInformation().setStatus(status);
        updateById(req.getBasicInformation());
        return req.getBasicInformation().getId();
    }

    /**
     * 通过主键查询单条项目所有数据(政务端)
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public BasicInformationResponse selectOne(Long id) {

        BasicInformationResponse basicInformationResponse = new BasicInformationResponse();
        //项目基本信息
        basicInformationResponse.setBasicInformation(getById(id));
        //项目规划信息
        basicInformationResponse.setPlanInformation(planInformationService.lambdaQuery().eq(PlanInformation::getXmId, id).one());
        //项目建筑信息
        basicInformationResponse.setBuildingInformation(buildingInformationService.lambdaQuery().eq(BuildingInformation::getXmId, id).list());
        //五要素模型信息
        ZwIdPageReq zwIdPageReq = new ZwIdPageReq();
        zwIdPageReq.setXmId(id);
        basicInformationResponse.setWysmxResponses(wysmxInformationService.list(zwIdPageReq));
        //企业入驻信息
        basicInformationResponse.setQyrzInformation(qyrzInformationService.selectAll(zwIdPageReq));
        //项目图例
        basicInformationResponse.setProjectLegendResponses(projectLegendService.page(zwIdPageReq));
        //项目巡礼
        basicInformationResponse.setXmxl(xmxlService.list(zwIdPageReq));
        RemarkPageReq remarkPageReq = new RemarkPageReq();
        remarkPageReq.setXmId(id);
        //项目备忘录
        basicInformationResponse.setProjectRemarks(projectRemarkService.list(remarkPageReq));
        //其他信息
        basicInformationResponse.setProjectOtherInfos(otherInfoService.searchId(zwIdPageReq));
        return basicInformationResponse;
    }


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void removeByXmIds(List<Long> idList) {
        idList.forEach(x -> {
            //删除项目基本信息
            lambdaUpdate().eq(BasicInformation::getId, x).remove();
            //删除项目规划信息
            planInformationService.lambdaUpdate().eq(PlanInformation::getXmId, x).remove();
            //删除项目建筑信息
            buildingInformationService.lambdaUpdate().eq(BuildingInformation::getXmId, x).remove();
            //删除五要素模型信息
            wysmxInformationService.lambdaUpdate().eq(WysmxInformation::getXmId, x).remove();
            //删除月度进展信息
//            projectMonthInfoService.lambdaUpdate()
//                    .eq(ProjectMonthInfo::getXmId,x)
//                    .remove();
            //删除企业入驻信息
            qyrzInformationService.lambdaUpdate().eq(QyrzInformation::getXmId, x).remove();
            //删除项目图例
            projectLegendService.lambdaUpdate().eq(ProjectLegend::getXmId, x).remove();
            //删除项目巡礼
            xmxlService.lambdaUpdate().eq(Xmxl::getXmId, x).remove();
            //删除项目备忘录
            projectRemarkService.lambdaUpdate().eq(ProjectRemark::getXmId, x).remove();
            //删除其他信息
            otherInfoService.lambdaUpdate().eq(ProjectOtherInfo::getXmId, x).remove();
        });
    }

    /**
     * 企业端暂存
     */
    @Override
    public Long staging(AuditRequest req) {
        //先删再暂存，因为可能会多次暂存
        baseMapper.delete1(req.getBasicInformation().getId());
        baseMapper.delete2(req.getBasicInformation().getId());
        baseMapper.delete3(req.getBasicInformation().getId());
        baseMapper.delete4(req.getBasicInformation().getId());
        baseMapper.delete5(req.getBasicInformation().getId());

        baseMapper.insert1(req.getBasicInformation());
        baseMapper.insert2(req.getPlanInformation());

        req.getWysmxInformations().forEach(x -> baseMapper.insert3(x));

        baseMapper.insert4(req.getQyrzInformation());
        req.getProjectOtherInfos().forEach(x -> baseMapper.insert5(x));
        return req.getBasicInformation().getId();
    }

    /**
     * 通过主键查询单条项目所有数据(企业端)
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public BasicInformationResponse stagingInfo(Long id) {
        BasicInformationResponse basicInformationResponse = new BasicInformationResponse();
        //项目基本信息
        BasicInformation bs = baseMapper.select1(id);
        if (bs != null) {
            basicInformationResponse.setBasicInformation(bs);
        } else {
            basicInformationResponse.setBasicInformation(getById(id));
        }
        //项目规划信息
        PlanInformation pl = baseMapper.select2(id);
        if (pl != null) {
            basicInformationResponse.setPlanInformation(pl);
        } else {
            basicInformationResponse.setPlanInformation(planInformationService.lambdaQuery().eq(PlanInformation::getXmId, id).one());
        }
        //项目建筑信息
        basicInformationResponse.setBuildingInformation(buildingInformationService.lambdaQuery().eq(BuildingInformation::getXmId, id).list());
        //五要素模型信息
        ZwIdPageReq zwIdPageReq = new ZwIdPageReq();
        zwIdPageReq.setXmId(id);
        List<WysmxInformation> wm = baseMapper.select3(id);
        if (!wm.isEmpty()) {
            basicInformationResponse.setWysmxResponses(wysmxInformationService.getWysFinal(wm));
        } else {
            basicInformationResponse.setWysmxResponses(wysmxInformationService.list(zwIdPageReq));
        }
        //企业入驻信息
        QyrzInformation qi = baseMapper.select4(id);
        if (qi != null) {
            basicInformationResponse.setQyrzInformation(qi);
        } else {
            basicInformationResponse.setQyrzInformation(qyrzInformationService.selectAll(zwIdPageReq));
        }
        //项目图例
        basicInformationResponse.setProjectLegendResponses(projectLegendService.page(zwIdPageReq));
        //项目巡礼
        basicInformationResponse.setXmxl(xmxlService.list(zwIdPageReq));
        RemarkPageReq remarkPageReq = new RemarkPageReq();
        remarkPageReq.setXmId(id);
        //项目备忘录
        basicInformationResponse.setProjectRemarks(projectRemarkService.list(remarkPageReq));
        //其他信息
        List<ProjectOtherInfo> po = baseMapper.select5(id);
        if (!po.isEmpty()) {
            basicInformationResponse.setProjectOtherInfos(po);
        } else {
            basicInformationResponse.setProjectOtherInfos(otherInfoService.searchId(zwIdPageReq));
        }
        return basicInformationResponse;
    }

    @Override
    public ByteArrayInputStream generateDocument(Map<String, Object> map) throws Exception {
        // 加载模板文件
        // InputStream inputStream = new ClassPathResource("xmdpcl.docx").getStream()
        ClassPathResource classPathResource = new ClassPathResource("xmdpcl.docx");
        try (InputStream inputStream = classPathResource.getStream()) {

            XWPFDocument document = new XWPFDocument(inputStream);

            // 替换模板中的占位符
            for (XWPFParagraph paragraph : document.getParagraphs()) {
                for (String key : map.keySet()) {
                    StringBuilder textBuilder = new StringBuilder();
                    for (XWPFRun run : paragraph.getRuns()) {
                        if (run != null && run.getText(0) != null) {
                            textBuilder.append(run.getText(0));
                        }
                    }
                    String text = textBuilder.toString();
                    if (text.contains("${" + key + "}")) {
                        text = text.replace("${" + key + "}", map.get(key).toString());
                        // 删除原有内容
                        while (paragraph.getRuns().size() > 0) {
                            paragraph.removeRun(0);
                        }
                        XWPFRun run = paragraph.createRun();
                        run.setText(text); // 设置替换后的内容
                    }
                }
            }
            // 将文档内容写入 ByteArrayOutputStream
            try (ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream()) {
                document.write(byteArrayOutputStream);
                // 将 ByteArrayOutputStream 转换为 ByteArrayInputStream 并返回
                return new ByteArrayInputStream(byteArrayOutputStream.toByteArray());
            }
        }
    }
}

