package com.ruoyi.gysl.service.impl;

import com.ruoyi.gysl.entity.Fmqd;
import com.ruoyi.gysl.mapper.FmqdServiceMapper;
import com.ruoyi.gysl.service.FmqdService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;


/**
 *负面清单管理 表服务实现类
 */
@Service
public class FmqdServiceImpl implements FmqdService {

    @Autowired
    private FmqdServiceMapper fmqdMapper;


    /**
     * 分页查询负面清单数据
     *
     * @param fmqd 查询条件实体
     * @return 分页数据
     */
    @Override
    public List<Fmqd> selectFmqdList(Fmqd fmqd) {
        return fmqdMapper.selectFmqdList(fmqd);
    }
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public Fmqd selectFmqdId(Integer id) {
        return fmqdMapper.selectFmqdById(id);
        }

    /**
     * 新增数据
     *@param fmqd 实体对象
     * @return 新增结果
     */
    @Override
    public int save(Fmqd fmqd) {
        return fmqdMapper.saveFmqd(fmqd);
    }
    /**
     * 修改数据
     *
     * @param fmqd 实体对象
     * @return 修改结果
     */
    @Override
    public int updateById(Fmqd fmqd) {
        return fmqdMapper.updateFmqd(fmqd);
    }
    /**
     * 删除数据
     *
     * @param id 实体对象
     * @return 删除结果
     */
    @Override
    public int deleteMapping(Integer id) {
        return fmqdMapper.deleteFmqd(id);
    }


}