package com.ruoyi.gysl.service.impl;

import com.ruoyi.gysl.entity.Ml;
import com.ruoyi.gysl.mapper.MlMapper;
import com.ruoyi.gysl.service.MlService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 *目录管理 表服务实现类
 */
@Service
public class MlServicImpl implements MlService {

    @Autowired
    private MlMapper mlMapper;

    /**
     * 查询目录信息
     *
     * @param ml 查询条件实体
     * @return 目录数据列表
     */
    @Override
    public List<Ml> selectMl(Ml ml) {
        return mlMapper.selectMlList(ml);
    }

    /**
     * 查询目录单条信息
     *
     * @param id 查询条件
     * @return 目录单条数据
     */
    @Override
    public Ml selectMlId(Integer id) {
        return mlMapper.selectMlById(id);
    }
    /**
     * 添加目录信息
     *
     * @param ml 添加信息
     * @return 新增结果
     */
    @Override
    public int saveMl(Ml ml) {
        return mlMapper.save(ml);
    }
    /**
     * 修改目录信息
     *
     * @param ml 修改信息
     * @return 修改结果
     */
    @Override
    public int updateById(Ml ml) {
        return mlMapper.updateMl(ml);
    }

    /**
     * 添加目录信息
     *
     * @param id 删除
     * @return 删除结果
     */
    @Override
    public int deleteMl(Integer id) {
        return mlMapper.deleteml(id);
    }

}
