package com.ruoyi.gysl.service.impl;

import com.ruoyi.gysl.entity.MonthInformation;
import com.ruoyi.gysl.mapper.MonthInformationMapper;
import com.ruoyi.gysl.service.MonthInformationService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

/**
 * 月度进展信息 表服务实现类
 */
@Service
public class MonthInformationImpl  implements MonthInformationService {

    @Autowired
    private MonthInformationMapper monthInformationMapper;
    /**
     * 分页查询月度进展信息
     *
     * @param monthInformation 查询实体
     * @return 所有数据
     */
    @Override
    public List<MonthInformation> selectMonthInformation(MonthInformation monthInformation) {
        return monthInformationMapper.selectMonthInformationList(monthInformation);
    }
    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @Override
    public MonthInformation selectMonthInformationId(Integer id) {
        return monthInformationMapper.selectMonthInformationId(id);
    }
    /**
     * 新增数据
     *
     * @param monthInformation 查询条件实体
     * @return 新增结果
     */
    @Override
    public int saveMonthInformation(MonthInformation monthInformation) {
        return monthInformationMapper.save(monthInformation);
    }
    /**
     * 修改数据
     *
     * @param monthInformation 实体对象
     * @return 修改结果
     */
    @Override
    public int updateById(MonthInformation monthInformation) {
        return monthInformationMapper.updateMonthInformation(monthInformation);
    }
    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除结果
     */
    @Override
    public int deleteMonthInformation(Integer id) {
        return monthInformationMapper.deletemonthInformation(id);
    }
}
