package com.ruoyi.docking.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 项目（对接数据）(Project)表实体类
 *
 * @author makejava
 * @since 2025-03-25 15:12:38
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("project")
@ApiModel(value="项目",description = "对接数据")
public class Project {


    @ApiModelProperty(value ="项目ID" )
    private Integer projectId;
   

    @ApiModelProperty(value ="项目名称" )
    private String projectName;
   

    @ApiModelProperty(value ="单位代码" )
    private String companyId;
   

    @ApiModelProperty(value ="单位名称" )
    private String companyName;
   

    @ApiModelProperty(value ="成立日期" )
    private String companyTime;
   

    @ApiModelProperty(value ="代建单位代码" )
    private String agentCompanyId;
   

    @ApiModelProperty(value ="代建单位名称" )
    private String agentCompanyName;
   

    @ApiModelProperty(value ="企业联系人姓名" )
    private String contactName;
   

    @ApiModelProperty(value ="企业联系人电话" )
    private String contactPhone;
   

    @ApiModelProperty(value ="项目申报类型" )
    private String projectType;
   

    @ApiModelProperty(value ="部门ID" )
    private String organizationId;
   

    @ApiModelProperty(value ="二级部门ID" )
    private String subOrganizationId;
   

    @ApiModelProperty(value ="招商部门ID" )
    private String zsOrganizationId;
   

    @ApiModelProperty(value ="一级项目类型" )
    private String typeId;
   

    @ApiModelProperty(value ="二级项目类型" )
    private String secondTypeId;
   

    @ApiModelProperty(value ="三级项目类型" )
    private String thirdTypeId;
   

    @ApiModelProperty(value ="实事项目一级分类" )
    private String ssTypeId;
   

    @ApiModelProperty(value ="版块区域" )
    private String areaId;
   

    @ApiModelProperty(value ="地点" )
    private String address;
   

    @ApiModelProperty(value ="纬度" )
    private String lat;
   

    @ApiModelProperty(value ="经度" )
    private String lng;
   

    @ApiModelProperty(value ="实际开工时间" )
    private String actualStartTime;
   

    @ApiModelProperty(value ="实际竣工时间" )
    private String actualEndTime;
   

    @ApiModelProperty(value ="竣工验收情况" )
    private String jgysStatus;
   

    @ApiModelProperty(value ="投产投用情况" )
    private String tctyStatus;
   

    @ApiModelProperty(value ="投产投用时间" )
    private String operationTime;
   

    @ApiModelProperty(value ="投资类别" )
    private String investmentType;
   

    @ApiModelProperty(value ="投资主体" )
    private String investmentEntity;
   

    @ApiModelProperty(value ="投资主体性质" )
    private String investmentEntityType;
   

    @ApiModelProperty(value ="形象图片" )
    private String thumbnail;
   

    @ApiModelProperty(value ="备注" )
    private String remark;
   

    @ApiModelProperty(value ="状态" )
    private String status;
   

    @ApiModelProperty(value ="审核阶段" )
    private Integer reviewStep;
   

    @ApiModelProperty(value ="0：无需审核,review_step=3，1，项目，2：计划/结转" )
    private Integer reviewObject;
   

    @ApiModelProperty(value ="审核结果" )
    private Integer reviewResult;
   

    @ApiModelProperty(value ="项目形象进度" )
    private String progressContent;
   

    @ApiModelProperty(value ="项目进度更新时间" )
    private Integer progressUpdateAt;
   

    @ApiModelProperty(value ="外部项目ID" )
    private String extProjectId;
   

    @ApiModelProperty(value ="省投资项目ID" )
    private String stzProjectId;
   

    @ApiModelProperty(value ="施工许可项目编码" )
    private String sgxkProjectId;
   

    @ApiModelProperty(value ="用地规划项目编码" )
    private Integer ydghProjectId;
   

    @ApiModelProperty(value ="工程规划项目编码" )
    private Integer gcghProjectId;
   

    @ApiModelProperty(value ="环评项目编码" )
    private Integer hpProjectId;
   

    @ApiModelProperty(value ="生成系统项目编码" )
    private String genProjectId;
   

    @ApiModelProperty(value ="地块编号" )
    private String landId;
   

    @ApiModelProperty(value ="云平台重点项目编码" )
    private String zdxmProjectId;
   

    @ApiModelProperty(value ="应报尽报项目编码" )
    private String ybjbProjectId;
   

    @ApiModelProperty(value ="落地时间" )
    private String landingTime;
   

    @ApiModelProperty(value ="是否落地" )
    private Integer landing;
   

    @ApiModelProperty(value ="维度ID" )
    private String dimensionIds;
   

    @ApiModelProperty(value ="指挥部ID" )
    private String headquarterIds;
   

    @ApiModelProperty(value ="竣工验收备案id" )
    private Integer jgysbaId;
   

    @ApiModelProperty(value ="能评id" )
    private Integer npId;
   

    @ApiModelProperty(value ="消防验收id" )
    private Integer xfysId;
   

    @ApiModelProperty(value ="是否为无效项目" )
    private Integer isDisabled;
   

    @ApiModelProperty(value ="是否列入统计" )
    private Integer isStats;
   

    @ApiModelProperty(value ="是否为草稿" )
    private Integer isDraft;
   

    @ApiModelProperty(value ="创建时间" )
    private Integer createdAt;
   

    @ApiModelProperty(value ="更新时间" )
    private Integer updatedAt;
   

    @ApiModelProperty(value ="创建用户" )
    private String createdBy;
   

    @ApiModelProperty(value ="删除标记" )
    private Integer isDeleted;
   

    @ApiModelProperty(value ="宗地号" )
    private String landNo;
   

    @ApiModelProperty(value ="宗地用途" )
    private String landUsage;
   

    @ApiModelProperty(value ="宗地面积" )
    private String landArea;
   

    @ApiModelProperty(value ="宗地位置" )
    private String landAddress;
   

    @ApiModelProperty(value ="宗地约定开工时间" )
    private String landStartDate;
   

    @ApiModelProperty(value ="宗地号约定竣工时间" )
    private String landEndDate;
   

    @ApiModelProperty(value ="宗地权利人名称" )
    private String landObligeeName;
   

    @ApiModelProperty(value ="宗地批准时间" )
    private String landApproveTime;
   

    @ApiModelProperty(value ="首页项目巡礼是否展示" )
    private Integer homeDisplay;
   

    @ApiModelProperty(value ="是否分期：0-否，1-是" )
    private Integer installment;
   

    @ApiModelProperty(value ="项目期数" )
    private Integer installmentNum;
}

